package com.wechi.adweb.bridge.google.analytics.dto.report.data;

import static com.wechi.adweb.bridge.google.analytics.dto.report.ReportConstant.*;

import com.google.analytics.data.v1beta.Row;

import lombok.Builder;
import lombok.Data;

import java.util.List;

/**
 * @author wfansh
 */
@Data
@Builder
public class CountryChartData implements GAReportDataDTO {
    private String country;
    private int num;

    public static List<CountryChartData> toReport(
            List<Row> reportRows, List<String> metrics, List<String> dimensions) {
        int indexCountry = dimensions.indexOf(DIMENSION_COUNTRY);

        return reportRows.stream()
                .map(
                        row ->
                                CountryChartData.builder()
                                        .country(row.getDimensionValues(indexCountry).getValue())
                                        // The first metric value - for customized metrics query.
                                        .num(Integer.parseInt(row.getMetricValues(0).getValue()))
                                        .build())
                .toList();
    }
}
